/*
 * Gitea API.
 * This documentation describes the Gitea API.
 *
 * The version of the OpenAPI document: 1.1.1
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package io.gitea.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.gitea.model.ExternalTracker;
import io.gitea.model.ExternalWiki;
import io.gitea.model.InternalTracker;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.io.IOException;

/**
 * EditRepoOption options when editing a repository&#39;s properties
 */
@ApiModel(description = "EditRepoOption options when editing a repository's properties")
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen")
public class EditRepoOption {
  public static final String SERIALIZED_NAME_ALLOW_MERGE_COMMITS = "allow_merge_commits";
  @SerializedName(SERIALIZED_NAME_ALLOW_MERGE_COMMITS)
  private Boolean allowMergeCommits;

  public static final String SERIALIZED_NAME_ALLOW_REBASE = "allow_rebase";
  @SerializedName(SERIALIZED_NAME_ALLOW_REBASE)
  private Boolean allowRebase;

  public static final String SERIALIZED_NAME_ALLOW_REBASE_EXPLICIT = "allow_rebase_explicit";
  @SerializedName(SERIALIZED_NAME_ALLOW_REBASE_EXPLICIT)
  private Boolean allowRebaseExplicit;

  public static final String SERIALIZED_NAME_ALLOW_SQUASH_MERGE = "allow_squash_merge";
  @SerializedName(SERIALIZED_NAME_ALLOW_SQUASH_MERGE)
  private Boolean allowSquashMerge;

  public static final String SERIALIZED_NAME_ARCHIVED = "archived";
  @SerializedName(SERIALIZED_NAME_ARCHIVED)
  private Boolean archived;

  public static final String SERIALIZED_NAME_DEFAULT_BRANCH = "default_branch";
  @SerializedName(SERIALIZED_NAME_DEFAULT_BRANCH)
  private String defaultBranch;

  public static final String SERIALIZED_NAME_DESCRIPTION = "description";
  @SerializedName(SERIALIZED_NAME_DESCRIPTION)
  private String description;

  public static final String SERIALIZED_NAME_EXTERNAL_TRACKER = "external_tracker";
  @SerializedName(SERIALIZED_NAME_EXTERNAL_TRACKER)
  private ExternalTracker externalTracker;

  public static final String SERIALIZED_NAME_EXTERNAL_WIKI = "external_wiki";
  @SerializedName(SERIALIZED_NAME_EXTERNAL_WIKI)
  private ExternalWiki externalWiki;

  public static final String SERIALIZED_NAME_HAS_ISSUES = "has_issues";
  @SerializedName(SERIALIZED_NAME_HAS_ISSUES)
  private Boolean hasIssues;

  public static final String SERIALIZED_NAME_HAS_PROJECTS = "has_projects";
  @SerializedName(SERIALIZED_NAME_HAS_PROJECTS)
  private Boolean hasProjects;

  public static final String SERIALIZED_NAME_HAS_PULL_REQUESTS = "has_pull_requests";
  @SerializedName(SERIALIZED_NAME_HAS_PULL_REQUESTS)
  private Boolean hasPullRequests;

  public static final String SERIALIZED_NAME_HAS_WIKI = "has_wiki";
  @SerializedName(SERIALIZED_NAME_HAS_WIKI)
  private Boolean hasWiki;

  public static final String SERIALIZED_NAME_IGNORE_WHITESPACE_CONFLICTS = "ignore_whitespace_conflicts";
  @SerializedName(SERIALIZED_NAME_IGNORE_WHITESPACE_CONFLICTS)
  private Boolean ignoreWhitespaceConflicts;

  public static final String SERIALIZED_NAME_INTERNAL_TRACKER = "internal_tracker";
  @SerializedName(SERIALIZED_NAME_INTERNAL_TRACKER)
  private InternalTracker internalTracker;

  public static final String SERIALIZED_NAME_NAME = "name";
  @SerializedName(SERIALIZED_NAME_NAME)
  private String name;

  public static final String SERIALIZED_NAME_PRIVATE = "private";
  @SerializedName(SERIALIZED_NAME_PRIVATE)
  private Boolean _private;

  public static final String SERIALIZED_NAME_TEMPLATE = "template";
  @SerializedName(SERIALIZED_NAME_TEMPLATE)
  private Boolean template;

  public static final String SERIALIZED_NAME_WEBSITE = "website";
  @SerializedName(SERIALIZED_NAME_WEBSITE)
  private String website;


  public EditRepoOption allowMergeCommits(Boolean allowMergeCommits) {
    
    this.allowMergeCommits = allowMergeCommits;
    return this;
  }

   /**
   * either &#x60;true&#x60; to allow merging pull requests with a merge commit, or &#x60;false&#x60; to prevent merging pull requests with merge commits. &#x60;has_pull_requests&#x60; must be &#x60;true&#x60;.
   * @return allowMergeCommits
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "either `true` to allow merging pull requests with a merge commit, or `false` to prevent merging pull requests with merge commits. `has_pull_requests` must be `true`.")

  public Boolean getAllowMergeCommits() {
    return allowMergeCommits;
  }


  public void setAllowMergeCommits(Boolean allowMergeCommits) {
    this.allowMergeCommits = allowMergeCommits;
  }


  public EditRepoOption allowRebase(Boolean allowRebase) {
    
    this.allowRebase = allowRebase;
    return this;
  }

   /**
   * either &#x60;true&#x60; to allow rebase-merging pull requests, or &#x60;false&#x60; to prevent rebase-merging. &#x60;has_pull_requests&#x60; must be &#x60;true&#x60;.
   * @return allowRebase
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "either `true` to allow rebase-merging pull requests, or `false` to prevent rebase-merging. `has_pull_requests` must be `true`.")

  public Boolean getAllowRebase() {
    return allowRebase;
  }


  public void setAllowRebase(Boolean allowRebase) {
    this.allowRebase = allowRebase;
  }


  public EditRepoOption allowRebaseExplicit(Boolean allowRebaseExplicit) {
    
    this.allowRebaseExplicit = allowRebaseExplicit;
    return this;
  }

   /**
   * either &#x60;true&#x60; to allow rebase with explicit merge commits (--no-ff), or &#x60;false&#x60; to prevent rebase with explicit merge commits. &#x60;has_pull_requests&#x60; must be &#x60;true&#x60;.
   * @return allowRebaseExplicit
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "either `true` to allow rebase with explicit merge commits (--no-ff), or `false` to prevent rebase with explicit merge commits. `has_pull_requests` must be `true`.")

  public Boolean getAllowRebaseExplicit() {
    return allowRebaseExplicit;
  }


  public void setAllowRebaseExplicit(Boolean allowRebaseExplicit) {
    this.allowRebaseExplicit = allowRebaseExplicit;
  }


  public EditRepoOption allowSquashMerge(Boolean allowSquashMerge) {
    
    this.allowSquashMerge = allowSquashMerge;
    return this;
  }

   /**
   * either &#x60;true&#x60; to allow squash-merging pull requests, or &#x60;false&#x60; to prevent squash-merging. &#x60;has_pull_requests&#x60; must be &#x60;true&#x60;.
   * @return allowSquashMerge
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "either `true` to allow squash-merging pull requests, or `false` to prevent squash-merging. `has_pull_requests` must be `true`.")

  public Boolean getAllowSquashMerge() {
    return allowSquashMerge;
  }


  public void setAllowSquashMerge(Boolean allowSquashMerge) {
    this.allowSquashMerge = allowSquashMerge;
  }


  public EditRepoOption archived(Boolean archived) {
    
    this.archived = archived;
    return this;
  }

   /**
   * set to &#x60;true&#x60; to archive this repository.
   * @return archived
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "set to `true` to archive this repository.")

  public Boolean getArchived() {
    return archived;
  }


  public void setArchived(Boolean archived) {
    this.archived = archived;
  }


  public EditRepoOption defaultBranch(String defaultBranch) {
    
    this.defaultBranch = defaultBranch;
    return this;
  }

   /**
   * sets the default branch for this repository.
   * @return defaultBranch
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "sets the default branch for this repository.")

  public String getDefaultBranch() {
    return defaultBranch;
  }


  public void setDefaultBranch(String defaultBranch) {
    this.defaultBranch = defaultBranch;
  }


  public EditRepoOption description(String description) {
    
    this.description = description;
    return this;
  }

   /**
   * a short description of the repository.
   * @return description
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "a short description of the repository.")

  public String getDescription() {
    return description;
  }


  public void setDescription(String description) {
    this.description = description;
  }


  public EditRepoOption externalTracker(ExternalTracker externalTracker) {
    
    this.externalTracker = externalTracker;
    return this;
  }

   /**
   * Get externalTracker
   * @return externalTracker
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "")

  public ExternalTracker getExternalTracker() {
    return externalTracker;
  }


  public void setExternalTracker(ExternalTracker externalTracker) {
    this.externalTracker = externalTracker;
  }


  public EditRepoOption externalWiki(ExternalWiki externalWiki) {
    
    this.externalWiki = externalWiki;
    return this;
  }

   /**
   * Get externalWiki
   * @return externalWiki
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "")

  public ExternalWiki getExternalWiki() {
    return externalWiki;
  }


  public void setExternalWiki(ExternalWiki externalWiki) {
    this.externalWiki = externalWiki;
  }


  public EditRepoOption hasIssues(Boolean hasIssues) {
    
    this.hasIssues = hasIssues;
    return this;
  }

   /**
   * either &#x60;true&#x60; to enable issues for this repository or &#x60;false&#x60; to disable them.
   * @return hasIssues
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "either `true` to enable issues for this repository or `false` to disable them.")

  public Boolean getHasIssues() {
    return hasIssues;
  }


  public void setHasIssues(Boolean hasIssues) {
    this.hasIssues = hasIssues;
  }


  public EditRepoOption hasProjects(Boolean hasProjects) {
    
    this.hasProjects = hasProjects;
    return this;
  }

   /**
   * either &#x60;true&#x60; to enable project unit, or &#x60;false&#x60; to disable them.
   * @return hasProjects
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "either `true` to enable project unit, or `false` to disable them.")

  public Boolean getHasProjects() {
    return hasProjects;
  }


  public void setHasProjects(Boolean hasProjects) {
    this.hasProjects = hasProjects;
  }


  public EditRepoOption hasPullRequests(Boolean hasPullRequests) {
    
    this.hasPullRequests = hasPullRequests;
    return this;
  }

   /**
   * either &#x60;true&#x60; to allow pull requests, or &#x60;false&#x60; to prevent pull request.
   * @return hasPullRequests
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "either `true` to allow pull requests, or `false` to prevent pull request.")

  public Boolean getHasPullRequests() {
    return hasPullRequests;
  }


  public void setHasPullRequests(Boolean hasPullRequests) {
    this.hasPullRequests = hasPullRequests;
  }


  public EditRepoOption hasWiki(Boolean hasWiki) {
    
    this.hasWiki = hasWiki;
    return this;
  }

   /**
   * either &#x60;true&#x60; to enable the wiki for this repository or &#x60;false&#x60; to disable it.
   * @return hasWiki
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "either `true` to enable the wiki for this repository or `false` to disable it.")

  public Boolean getHasWiki() {
    return hasWiki;
  }


  public void setHasWiki(Boolean hasWiki) {
    this.hasWiki = hasWiki;
  }


  public EditRepoOption ignoreWhitespaceConflicts(Boolean ignoreWhitespaceConflicts) {
    
    this.ignoreWhitespaceConflicts = ignoreWhitespaceConflicts;
    return this;
  }

   /**
   * either &#x60;true&#x60; to ignore whitespace for conflicts, or &#x60;false&#x60; to not ignore whitespace. &#x60;has_pull_requests&#x60; must be &#x60;true&#x60;.
   * @return ignoreWhitespaceConflicts
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "either `true` to ignore whitespace for conflicts, or `false` to not ignore whitespace. `has_pull_requests` must be `true`.")

  public Boolean getIgnoreWhitespaceConflicts() {
    return ignoreWhitespaceConflicts;
  }


  public void setIgnoreWhitespaceConflicts(Boolean ignoreWhitespaceConflicts) {
    this.ignoreWhitespaceConflicts = ignoreWhitespaceConflicts;
  }


  public EditRepoOption internalTracker(InternalTracker internalTracker) {
    
    this.internalTracker = internalTracker;
    return this;
  }

   /**
   * Get internalTracker
   * @return internalTracker
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "")

  public InternalTracker getInternalTracker() {
    return internalTracker;
  }


  public void setInternalTracker(InternalTracker internalTracker) {
    this.internalTracker = internalTracker;
  }


  public EditRepoOption name(String name) {
    
    this.name = name;
    return this;
  }

   /**
   * name of the repository
   * @return name
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "name of the repository")

  public String getName() {
    return name;
  }


  public void setName(String name) {
    this.name = name;
  }


  public EditRepoOption _private(Boolean _private) {
    
    this._private = _private;
    return this;
  }

   /**
   * either &#x60;true&#x60; to make the repository private or &#x60;false&#x60; to make it public. Note: you will get a 422 error if the organization restricts changing repository visibility to organization owners and a non-owner tries to change the value of private.
   * @return _private
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "either `true` to make the repository private or `false` to make it public. Note: you will get a 422 error if the organization restricts changing repository visibility to organization owners and a non-owner tries to change the value of private.")

  public Boolean getPrivate() {
    return _private;
  }


  public void setPrivate(Boolean _private) {
    this._private = _private;
  }


  public EditRepoOption template(Boolean template) {
    
    this.template = template;
    return this;
  }

   /**
   * either &#x60;true&#x60; to make this repository a template or &#x60;false&#x60; to make it a normal repository
   * @return template
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "either `true` to make this repository a template or `false` to make it a normal repository")

  public Boolean getTemplate() {
    return template;
  }


  public void setTemplate(Boolean template) {
    this.template = template;
  }


  public EditRepoOption website(String website) {
    
    this.website = website;
    return this;
  }

   /**
   * a URL with more information about the repository.
   * @return website
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "a URL with more information about the repository.")

  public String getWebsite() {
    return website;
  }


  public void setWebsite(String website) {
    this.website = website;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    EditRepoOption editRepoOption = (EditRepoOption) o;
    return Objects.equals(this.allowMergeCommits, editRepoOption.allowMergeCommits) &&
        Objects.equals(this.allowRebase, editRepoOption.allowRebase) &&
        Objects.equals(this.allowRebaseExplicit, editRepoOption.allowRebaseExplicit) &&
        Objects.equals(this.allowSquashMerge, editRepoOption.allowSquashMerge) &&
        Objects.equals(this.archived, editRepoOption.archived) &&
        Objects.equals(this.defaultBranch, editRepoOption.defaultBranch) &&
        Objects.equals(this.description, editRepoOption.description) &&
        Objects.equals(this.externalTracker, editRepoOption.externalTracker) &&
        Objects.equals(this.externalWiki, editRepoOption.externalWiki) &&
        Objects.equals(this.hasIssues, editRepoOption.hasIssues) &&
        Objects.equals(this.hasProjects, editRepoOption.hasProjects) &&
        Objects.equals(this.hasPullRequests, editRepoOption.hasPullRequests) &&
        Objects.equals(this.hasWiki, editRepoOption.hasWiki) &&
        Objects.equals(this.ignoreWhitespaceConflicts, editRepoOption.ignoreWhitespaceConflicts) &&
        Objects.equals(this.internalTracker, editRepoOption.internalTracker) &&
        Objects.equals(this.name, editRepoOption.name) &&
        Objects.equals(this._private, editRepoOption._private) &&
        Objects.equals(this.template, editRepoOption.template) &&
        Objects.equals(this.website, editRepoOption.website);
  }

  @Override
  public int hashCode() {
    return Objects.hash(allowMergeCommits, allowRebase, allowRebaseExplicit, allowSquashMerge, archived, defaultBranch, description, externalTracker, externalWiki, hasIssues, hasProjects, hasPullRequests, hasWiki, ignoreWhitespaceConflicts, internalTracker, name, _private, template, website);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class EditRepoOption {\n");
    sb.append("    allowMergeCommits: ").append(toIndentedString(allowMergeCommits)).append("\n");
    sb.append("    allowRebase: ").append(toIndentedString(allowRebase)).append("\n");
    sb.append("    allowRebaseExplicit: ").append(toIndentedString(allowRebaseExplicit)).append("\n");
    sb.append("    allowSquashMerge: ").append(toIndentedString(allowSquashMerge)).append("\n");
    sb.append("    archived: ").append(toIndentedString(archived)).append("\n");
    sb.append("    defaultBranch: ").append(toIndentedString(defaultBranch)).append("\n");
    sb.append("    description: ").append(toIndentedString(description)).append("\n");
    sb.append("    externalTracker: ").append(toIndentedString(externalTracker)).append("\n");
    sb.append("    externalWiki: ").append(toIndentedString(externalWiki)).append("\n");
    sb.append("    hasIssues: ").append(toIndentedString(hasIssues)).append("\n");
    sb.append("    hasProjects: ").append(toIndentedString(hasProjects)).append("\n");
    sb.append("    hasPullRequests: ").append(toIndentedString(hasPullRequests)).append("\n");
    sb.append("    hasWiki: ").append(toIndentedString(hasWiki)).append("\n");
    sb.append("    ignoreWhitespaceConflicts: ").append(toIndentedString(ignoreWhitespaceConflicts)).append("\n");
    sb.append("    internalTracker: ").append(toIndentedString(internalTracker)).append("\n");
    sb.append("    name: ").append(toIndentedString(name)).append("\n");
    sb.append("    _private: ").append(toIndentedString(_private)).append("\n");
    sb.append("    template: ").append(toIndentedString(template)).append("\n");
    sb.append("    website: ").append(toIndentedString(website)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

