/*
 * Gitea API.
 * This documentation describes the Gitea API.
 *
 * The version of the OpenAPI document: 1.1.1
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package io.gitea.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.gitea.model.GPGKeyEmail;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.io.IOException;
import java.time.OffsetDateTime;
import java.util.ArrayList;
import java.util.List;

/**
 * GPGKey a user GPG key to sign commit and tag in repository
 */
@ApiModel(description = "GPGKey a user GPG key to sign commit and tag in repository")
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen")
public class GPGKey {
  public static final String SERIALIZED_NAME_CAN_CERTIFY = "can_certify";
  @SerializedName(SERIALIZED_NAME_CAN_CERTIFY)
  private Boolean canCertify;

  public static final String SERIALIZED_NAME_CAN_ENCRYPT_COMMS = "can_encrypt_comms";
  @SerializedName(SERIALIZED_NAME_CAN_ENCRYPT_COMMS)
  private Boolean canEncryptComms;

  public static final String SERIALIZED_NAME_CAN_ENCRYPT_STORAGE = "can_encrypt_storage";
  @SerializedName(SERIALIZED_NAME_CAN_ENCRYPT_STORAGE)
  private Boolean canEncryptStorage;

  public static final String SERIALIZED_NAME_CAN_SIGN = "can_sign";
  @SerializedName(SERIALIZED_NAME_CAN_SIGN)
  private Boolean canSign;

  public static final String SERIALIZED_NAME_CREATED_AT = "created_at";
  @SerializedName(SERIALIZED_NAME_CREATED_AT)
  private OffsetDateTime createdAt;

  public static final String SERIALIZED_NAME_EMAILS = "emails";
  @SerializedName(SERIALIZED_NAME_EMAILS)
  private List<GPGKeyEmail> emails = null;

  public static final String SERIALIZED_NAME_EXPIRES_AT = "expires_at";
  @SerializedName(SERIALIZED_NAME_EXPIRES_AT)
  private OffsetDateTime expiresAt;

  public static final String SERIALIZED_NAME_ID = "id";
  @SerializedName(SERIALIZED_NAME_ID)
  private Long id;

  public static final String SERIALIZED_NAME_KEY_ID = "key_id";
  @SerializedName(SERIALIZED_NAME_KEY_ID)
  private String keyId;

  public static final String SERIALIZED_NAME_PRIMARY_KEY_ID = "primary_key_id";
  @SerializedName(SERIALIZED_NAME_PRIMARY_KEY_ID)
  private String primaryKeyId;

  public static final String SERIALIZED_NAME_PUBLIC_KEY = "public_key";
  @SerializedName(SERIALIZED_NAME_PUBLIC_KEY)
  private String publicKey;

  public static final String SERIALIZED_NAME_SUBKEYS = "subkeys";
  @SerializedName(SERIALIZED_NAME_SUBKEYS)
  private List<GPGKey> subkeys = null;


  public GPGKey canCertify(Boolean canCertify) {
    
    this.canCertify = canCertify;
    return this;
  }

   /**
   * Get canCertify
   * @return canCertify
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "")

  public Boolean getCanCertify() {
    return canCertify;
  }


  public void setCanCertify(Boolean canCertify) {
    this.canCertify = canCertify;
  }


  public GPGKey canEncryptComms(Boolean canEncryptComms) {
    
    this.canEncryptComms = canEncryptComms;
    return this;
  }

   /**
   * Get canEncryptComms
   * @return canEncryptComms
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "")

  public Boolean getCanEncryptComms() {
    return canEncryptComms;
  }


  public void setCanEncryptComms(Boolean canEncryptComms) {
    this.canEncryptComms = canEncryptComms;
  }


  public GPGKey canEncryptStorage(Boolean canEncryptStorage) {
    
    this.canEncryptStorage = canEncryptStorage;
    return this;
  }

   /**
   * Get canEncryptStorage
   * @return canEncryptStorage
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "")

  public Boolean getCanEncryptStorage() {
    return canEncryptStorage;
  }


  public void setCanEncryptStorage(Boolean canEncryptStorage) {
    this.canEncryptStorage = canEncryptStorage;
  }


  public GPGKey canSign(Boolean canSign) {
    
    this.canSign = canSign;
    return this;
  }

   /**
   * Get canSign
   * @return canSign
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "")

  public Boolean getCanSign() {
    return canSign;
  }


  public void setCanSign(Boolean canSign) {
    this.canSign = canSign;
  }


  public GPGKey createdAt(OffsetDateTime createdAt) {
    
    this.createdAt = createdAt;
    return this;
  }

   /**
   * Get createdAt
   * @return createdAt
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "")

  public OffsetDateTime getCreatedAt() {
    return createdAt;
  }


  public void setCreatedAt(OffsetDateTime createdAt) {
    this.createdAt = createdAt;
  }


  public GPGKey emails(List<GPGKeyEmail> emails) {
    
    this.emails = emails;
    return this;
  }

  public GPGKey addEmailsItem(GPGKeyEmail emailsItem) {
    if (this.emails == null) {
      this.emails = new ArrayList<>();
    }
    this.emails.add(emailsItem);
    return this;
  }

   /**
   * Get emails
   * @return emails
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "")

  public List<GPGKeyEmail> getEmails() {
    return emails;
  }


  public void setEmails(List<GPGKeyEmail> emails) {
    this.emails = emails;
  }


  public GPGKey expiresAt(OffsetDateTime expiresAt) {
    
    this.expiresAt = expiresAt;
    return this;
  }

   /**
   * Get expiresAt
   * @return expiresAt
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "")

  public OffsetDateTime getExpiresAt() {
    return expiresAt;
  }


  public void setExpiresAt(OffsetDateTime expiresAt) {
    this.expiresAt = expiresAt;
  }


  public GPGKey id(Long id) {
    
    this.id = id;
    return this;
  }

   /**
   * Get id
   * @return id
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "")

  public Long getId() {
    return id;
  }


  public void setId(Long id) {
    this.id = id;
  }


  public GPGKey keyId(String keyId) {
    
    this.keyId = keyId;
    return this;
  }

   /**
   * Get keyId
   * @return keyId
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "")

  public String getKeyId() {
    return keyId;
  }


  public void setKeyId(String keyId) {
    this.keyId = keyId;
  }


  public GPGKey primaryKeyId(String primaryKeyId) {
    
    this.primaryKeyId = primaryKeyId;
    return this;
  }

   /**
   * Get primaryKeyId
   * @return primaryKeyId
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "")

  public String getPrimaryKeyId() {
    return primaryKeyId;
  }


  public void setPrimaryKeyId(String primaryKeyId) {
    this.primaryKeyId = primaryKeyId;
  }


  public GPGKey publicKey(String publicKey) {
    
    this.publicKey = publicKey;
    return this;
  }

   /**
   * Get publicKey
   * @return publicKey
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "")

  public String getPublicKey() {
    return publicKey;
  }


  public void setPublicKey(String publicKey) {
    this.publicKey = publicKey;
  }


  public GPGKey subkeys(List<GPGKey> subkeys) {
    
    this.subkeys = subkeys;
    return this;
  }

  public GPGKey addSubkeysItem(GPGKey subkeysItem) {
    if (this.subkeys == null) {
      this.subkeys = new ArrayList<>();
    }
    this.subkeys.add(subkeysItem);
    return this;
  }

   /**
   * Get subkeys
   * @return subkeys
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "")

  public List<GPGKey> getSubkeys() {
    return subkeys;
  }


  public void setSubkeys(List<GPGKey> subkeys) {
    this.subkeys = subkeys;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    GPGKey gpGKey = (GPGKey) o;
    return Objects.equals(this.canCertify, gpGKey.canCertify) &&
        Objects.equals(this.canEncryptComms, gpGKey.canEncryptComms) &&
        Objects.equals(this.canEncryptStorage, gpGKey.canEncryptStorage) &&
        Objects.equals(this.canSign, gpGKey.canSign) &&
        Objects.equals(this.createdAt, gpGKey.createdAt) &&
        Objects.equals(this.emails, gpGKey.emails) &&
        Objects.equals(this.expiresAt, gpGKey.expiresAt) &&
        Objects.equals(this.id, gpGKey.id) &&
        Objects.equals(this.keyId, gpGKey.keyId) &&
        Objects.equals(this.primaryKeyId, gpGKey.primaryKeyId) &&
        Objects.equals(this.publicKey, gpGKey.publicKey) &&
        Objects.equals(this.subkeys, gpGKey.subkeys);
  }

  @Override
  public int hashCode() {
    return Objects.hash(canCertify, canEncryptComms, canEncryptStorage, canSign, createdAt, emails, expiresAt, id, keyId, primaryKeyId, publicKey, subkeys);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class GPGKey {\n");
    sb.append("    canCertify: ").append(toIndentedString(canCertify)).append("\n");
    sb.append("    canEncryptComms: ").append(toIndentedString(canEncryptComms)).append("\n");
    sb.append("    canEncryptStorage: ").append(toIndentedString(canEncryptStorage)).append("\n");
    sb.append("    canSign: ").append(toIndentedString(canSign)).append("\n");
    sb.append("    createdAt: ").append(toIndentedString(createdAt)).append("\n");
    sb.append("    emails: ").append(toIndentedString(emails)).append("\n");
    sb.append("    expiresAt: ").append(toIndentedString(expiresAt)).append("\n");
    sb.append("    id: ").append(toIndentedString(id)).append("\n");
    sb.append("    keyId: ").append(toIndentedString(keyId)).append("\n");
    sb.append("    primaryKeyId: ").append(toIndentedString(primaryKeyId)).append("\n");
    sb.append("    publicKey: ").append(toIndentedString(publicKey)).append("\n");
    sb.append("    subkeys: ").append(toIndentedString(subkeys)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

